%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define version_maj 1
%define version_min 1
%define version_rev 0
%define version_tag SP7
%define version_full %{version_maj}.%{version_min}.%{version_rev}.%{version_tag}
 
Summary:        JBoss Web Services (common)
Name:           jbossws-common
Version:        %{version_maj}.%{version_min}.%{version_rev}
Release:        3.%{version_tag}.1%{?dist}
Epoch:          0
License:        LGPLv2+
Group:          Development/Java
URL:            http://labs.jboss.com/jbossws/

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildArch:      noarch
# svn export https://svn.jboss.org/repos/jbossws/common/tags/jbossws-common-1.1.0.SP7/
# Exported revision 13731.
# tar czf jbossws-common-1.1.0.SP7.tar.gz jbossws-common-1.1.0.SP7
Source0:        %{name}-%{version_full}.tar.gz
Source1:        %{name}-jpp-depmap.xml
Source2:        %{name}-component-info.xml
Source3:	jbossws-common-upload.sh
Patch0:         %{name}-pom.xml.patch

BuildRequires:  maven-deploy-plugin
BuildRequires:  maven2
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:	codehaus-stax11-api
BuildRequires:  glassfish-javamail
BuildRequires:  glassfish-jaxws
BuildRequires:  jboss-common-core
BuildRequires:  jboss-microcontainer2
BuildRequires:  jbossweb
BuildRequires:  jbossws
BuildRequires:  jboss-parent
BuildRequires:  junit >= 3.8.1
BuildRequires:  jbossws-parent
BuildRequires:  jboss-javaee-poms
BuildRequires:  jboss-ejb-3.0-api
BuildRequires:  jbossws-spi >= 1.1.0
BuildRequires:	sun-ws-metadata-2.0-api
BuildRequires:  sun-saaj-1.3-api

%description
JBossWS Common.

%define repodir_root repository.jboss.com
%define repodir_release jboss/%{name}/%{version_full}
%define repodir %{_javadir}/%{repodir_root}/%{repodir_release}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%if %{with_repolib}
%package     repolib
Summary:     Artifacts to be uploaded to a repository library
Group:  Development/Libraries/Java

%description     repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif


%prep

sed -i 's/@VERSION@/%{version_full}-brew/g' %{SOURCE2}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE2}

%setup -q -n %{name}-%{version_full}

%patch0 -p0

find . -name "*.jar" -exec rm -f {} \;

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL
mkdir -p ./output/reposave

mvn-jpp \
        -e \
        -Djboss.repository=file://%{_javadir}/repository.jboss.com \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.failure.ignore=false \
        -Dmaven.test.skip=true \
        -Djboss.local.repository=./output/reposave \
        install
### FIXME :  skipping test for now as this fails:
###Running org.jboss.test.ws.common.URLLoaderAdapterTestCase
### Tests run: 2, Failures: 0, Errors: 1, Skipped: 0, Time elapsed: 0.041 sec <<< FAILURE!
### Results :
### Tests in error:
### testWithDir(org.jboss.test.ws.common.URLLoaderAdapterTestCase)

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -p -m 0644 target/%{name}-%{version_full}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version_full}.jar
install -p -m 0644 target/%{name}-%{version_full}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version_full}-sources.jar

pushd $RPM_BUILD_ROOT%{_javadir}
ln -sf %{name}-%{version_full}.jar %{name}.jar
ln -sf %{name}-%{version_full}-sources.jar %{name}-sources.jar
popd

%if %{with_repolib}
    install -d -m 755 $RPM_BUILD_ROOT%{repodir}
    install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
    install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
    install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
    install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
    install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}

#    cp -R output/reposave/%{repodir_release}/* $RPM_BUILD_ROOT%{repodir}
    install -p -m 0644 target/%{name}-%{version_full}.jar $RPM_BUILD_ROOT%{repodirlib}/%{name}.jar
    install -p -m 0644 target/%{name}-%{version_full}-sources.jar $RPM_BUILD_ROOT%{repodirlib}/%{name}-sources.jar

    cp -a pom.xml $RPM_BUILD_ROOT%{repodirlib}/%{name}.pom

    # Clobber the existing component-info.xml with our patched, sed'ed version
    cp --remove-destination %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml

%{__install} -p -m 755 %{SOURCE3} %{buildroot}%{repodir}/upload.sh
pushd %{buildroot}%{repodir}
./upload.sh %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/
popd

%endif

%add_to_maven_depmap org.jboss.ws jbossws-common %{version_full} JPP %{name}

%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -a pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{version_full}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-%{version_full}-sources.jar
%{_javadir}*/%{name}-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}*
%{_javadir}*/repository.jboss.com
%endif


%changelog
* Thu Feb 10 2011 Yiqiao Wang <yiwang@redhat.com> - 0:1.1.0-3.SP7.1
- Upgrade to 1.1.0.SP7
- Patch pom.xml so that it uses jboss-microcontainer2

* Thu Jan 20 2011 Yiqiao Wang <yiwang@redhat.com> - 0:1.1.0-2.SP6.2
- Build with Maven 2.2.1
- Add upload.sh to repolib
- Fix %%files for signed jars
- Add content of maven2-brew, add BR maven-deploy-plugin
- Add the line to find and remove any binaries
- Change BR jboss-microcontainer to jboss-microcontainer2
- Patch pom.xml so that it uses jboss-microcontainer2

* Thu Jun 3 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.1.0-2.SP6.1
- Merge from RHEL4 (Upgrade to 1.1.0.SP6)

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.1.0-1.SP2_CP01.2.1
- rebuilt

* Wed Apr 21 2010 Hui Wang <huwang@redhat.om> 0:1.1.0-1.SP2_CP01.2
- Add BR: BuildRequires: sun-saaj-1.3-api
- Delete jbossws-native-jaxrpc dependency in depmap file
- Rebuild

* Thu Jan 21 2010 Martha Benitez <mbenitez@redhatc.om> 0:1.1.0-1.SP2_CP01.1
- Upgrade to 1.1.0.SP2_CP01
- Add BR codehaus-stax11-api, sun-ws-metadata-2.0-api and their depmap entries
- Change to %{version_full} for depmap entry

* Fri Nov 27 2009 Permaine Cheung <pcheung@redhat.com> 0:1.1.0-0.SP2.8
- Fix version of jaxb in pom

* Fri Oct 30 2009 Fernando Nasser <fnasser@redhat.com> 0:1.1.0-0.SP2.7
- Remove extra dependencies from POM as they should come from jbossws-spi

* Thu Oct 29 2009 Fernando Nasser <fnasser@redhat.com> 0:1.1.0-0.SP2.6
- Remove dependency on jbossws-native-saaj from POM

* Mon Sep 14 2009 Permaine Cheung <pcheung@redhat.com> 0:1.1.0-0.SP2.5
- Fix coordinates for jaxb-api
- Add pom to repolib

* Tue Jul 21 2009 Permaine Cheung <pcheung@redhat.com> 0:1.1.0-0.SP2.4
- Fix component-info.xml

* Mon Jul 20 2009 Permaine Cheung <pcheung@redhat.com> 0:1.1.0-0.SP2.3
- Rebuild to use latest jbossws

* Tue Jul 07 2009 Permaine Cheung <pcheung@redhat.com> 0:1.1.0-0.SP2.2
- Rebuild to fix groupId for jaxb-api

* Tue Jul 07 2009 Permaine Cheung <pcheung@redhat.com> 0:1.1.0-0.SP2.1
- Upgrade to 1.1.0.SP2
- Build with maven
- Add pom and fragment
- Use jbossws for building until we have jbossws-native built
